#include <stdio.h>
#include <string.h>  
#include <avr/io.h>  
#include <avr/eeprom.h>
#include "rf01.h"
#include "global.h"
  
#include "mmc.h"
#include "fat.h"
#include "usart.h"
#include <util/delay.h>
#include <avr/interrupt.h>

volatile int a;
volatile int playnow;
int b;
int dl2;	
unsigned char Buffer[512];
unsigned char playBuffer[512];
uint8_t  bufferChanged;
unsigned char playfile[12];
unsigned int datenempfang_ok;

void rx_datenverarb(void);
unsigned char data[10];
unsigned int timedummy=0;
unsigned int durchlauf=0;
unsigned char nichts_empf=0;

ISR(TIMER2_OVF_vect)
{

	TCNT2=160;	

	if(a<512)
	{
	OCR1A = playBuffer[a];a++;
	}



                                 
        
}










//Hauptprogramm
int main (void)
{
  //SYSCLK defined in usart.h
  //Initzialisierung der seriellen Schnittstelle

	datenempfang_ok=0;

  
   TCCR2 |= (1<<CS21); // Start timer at Fcpu/8

   //Enable Overflow Interrupt Enable
   TIMSK|=(1<<TOIE2);

  

   dl2=0;  

	playnow=1;
	playfile[0]='i';playfile[1]='n';playfile[2]='i';playfile[3]='t';playfile[4]='i';
	playfile[5]='.';playfile[6]='W';playfile[7]='A';playfile[8]='V';




 	rf01_init();					// ein paar Register setzen (z.B. CLK auf 10MHz)
	rf01_setfreq(RF01FREQ(433.30));	// Sende/Empfangsfrequenz auf 433,92MHz einstellen
	rf01_setbandwidth(4);			// 200kHz Bandbreite
	rf01_setreceiver(2,4);			// -6dB Verstrkung, DRSSI threshold: -79dBm 
	rf01_setbaud(19200);			// 19200 Baud
   












  
  //Initialisierung der MMC/SD-Karte
  usart_write("System Ready!\r\n");  
  while ( mmc_init() !=0) //ist der Rckgabewert ungleich NULL ist ein Fehler aufgetreten
    {
    usart_write("** Keine MMC/SD Karte gefunden!! **\n");  
    }
  usart_write("Karte gefunden!!\n");
  
  fat_init();//laden Cluster OFFSET und Size
  //Initialisierung der MMC/SD-Karte ENDE!

    unsigned int tmp;
  
  mmc_read_csd (Buffer);
  
  for (tmp = 0;tmp<16;tmp++)
    {
    usart_write("%x ",Buffer[tmp]);
    };


  //Ausgabe des Root Directory
  unsigned int Clustervar;
  unsigned char Dir_Attrib = 0;
  unsigned long Size = 0;
  usart_write("\r\nDirectory\r\n");
  for (char a = 1;a < 240;a++)
  {
    Clustervar = fat_read_dir_ent(0,a,&Size,&Dir_Attrib,Buffer);
      if (Clustervar == 0xffff)
      {
        break;
      }
    tmp = (Size & 0x0000FFFF);
    usart_write("Cluster = %4x DirA = %2x FileName = ",Clustervar,Dir_Attrib);
    usart_write("%s",Buffer);
    usart_write("\r\n");
  }
  usart_write("\r\nDirectory Ende\r\n");








  
  // INIT PWM
    
    DDRD = (1 << PD5 );
    TCCR1A = (1<<COM1A1) | (0<<COM1A0) | (0<<WGM11)  | (1<<WGM10) ;
    TCCR1B = (0<<CS12)   | (0<<CS11)   | (1<<CS10);

	DDRC = 0b00000111; //Verstrkerrelais, Lautsprecherrelais und Empf. Led. 
	DDRA |= ( 1 << DDA7) ; //Takt LED


  // INIT PWM ENDE

	timedummy=0;PORTA |= (1<<PA7);  //Takt Led ein

while (1)
  {
  
  

  	timedummy++;
	if(timedummy==100)
	{
	timedummy=0;PORTA |= (1<<PA7); //Takt Led ein
	if(nichts_empf>0){nichts_empf--;} //Sorgt dafr dass die LED leuchtet, wenn schon lnger nichts empfangen wurde
	} 

	if((timedummy==20)&&(nichts_empf>0)) //bedeutet auch dass in letzter zeit was empfangen wurde	
	{
	PORTA &= ~(1<<PA7); //Takt Led aus
	}

	if((timedummy==80)&&(nichts_empf==0)) //bedeutet auch dass in letzter zeit nichts empfangen wurde	
	{
	PORTA &= ~(1<<PA7); //Takt Led aus
	}




	//Falls die empf led ein sein sollte ( sie signalisiert dass was empfangen wurde )

	if(timedummy==1) {PORTC &= ~(1<<PC2);} //Empf Led wieder aus






  
  
  		data[0]=0;data[1]=0; 	//damit wieder erkannt werden kann		
		rf01_rxdata(data, 10); //empfange bis daten empfangen wurden
	
		
		
		if(data[0]!=0)
		{
		rx_datenverarb();		//prft ob daten korrekt ( doppelt gesendet ) und schreibt sie in das wirkliche Datenarray
		}



  
  
  
  
  
  
  
  
  
  
  
  
  
  
  

   if  ( playnow==1 ) 
   {
	
	
	//Lade Cluster fr das index.htm File in den Speicher 
    Clustervar = 0;//suche im Root Verzeichnis
    if (fat_search_file((unsigned char *) playfile,&Clustervar,&Size,&Dir_Attrib,Buffer) == 1)
    {


	PORTC |= (1<<PC0);  //Verstrker ein
	for(int y=0;y<10000;y++){asm("nop");}

	PORTC |= (1<<PC1);  //Lautsprecher ein
	for(long int y=0;y<70000;y++){asm("nop");} //Noch kurz warten bis es losgehen kann



	b=0;    



	//Ersten Datensatz lesen
	fat_read_file (Clustervar,Buffer,b);
	memcpy (playBuffer,Buffer,512);
	a=0;
	b=1;





	 //Interruptcounter initialisieren
    TCNT2=70;

	sei();



    //Lese File aus File
   		 while(b<(Size/512))
      		{
      
	 		 	if(a==512)
	  			{
	 
				memcpy (playBuffer,Buffer,512);
				a=0;
	  			fat_read_file (Clustervar,Buffer,b);
	
				b++;
		
      			}
	  		}

	
		cli();
		playnow=0;


		PORTC &= ~(1<<PC1); //Lautsprecher aus
	
	
		for(int h=0;h<10000;h++){asm("nop");}

	  	
		
		PORTC &= ~(1<<PC0); //Verstrker aus
	


    }//search file abauf
   }//port A3
  }//endlosschleife 
}//main















//________________________________________________________________________
//Empfangene Daten verarbeiten

void rx_datenverarb (void)
{
	


	PORTC |= (1<<PC2);  //Empf Led ein
	
	nichts_empf=200;




	if(datenempfang_ok==0)
	{


	playfile[0]='e';playfile[1]='m';playfile[2]='p';playfile[3]='f';
		
	playfile[4]='.';playfile[5]='W';playfile[6]='A';
	playfile[7]='V';playfile[8]='\0';

	playnow=1;
	datenempfang_ok=1;
	}





	if (   ((data[0]=='W') && (data[1]=='a') && (data[2]=='v') && (data[8]==';')))
	{


	









		int f=0;

		for (int k=3;k<8;k++)
		{
			playfile[f]=data[k];
			f++;
		}

		playfile[5]='.';playfile[6]='W';playfile[7]='A';playfile[8]='V';
		
		
	playnow=1;


	}






	

}





